代码随想录算法训练营第三十一天|贪心算法 part01|● 455.分发饼干 ● 376. 摆动序列 ● 53. 最大子序和

文章介绍了三道LeetCode算法题目,包括AssignCookies的饼干分配问题,采用排序策略优化解法;WiggleSubsequence的摆动序列,关注数列差异变化;以及MaximumSubarray的最大子序和,解决连续和的最大值问题。所有解法均关注时间复杂度和空间复杂度的优化。
摘要由CSDN通过智能技术生成

●  455.分发饼干  Assign Cookies - LeetCode

sort(胃口)

sort(饼干)

int res = 0;

int idex = s.length - 1;

从后往前投喂

一定要先遍历胃口,再遍历饼干

for (i = g.length - 1; i >= 0; i--)

        while (idx >= 0 && s[idx] >= g[i])

                res++;

                idx--;//成功投喂才移动

方法二:

用小饼干投喂,从小到大 Time complexity: O(nlogn) Space complexity: O(logn)

class Solution {
    public int findContentChildren(int[] g, int[] s) {
        Arrays.sort(g);
        Arrays.sort(s);
        int res = 0;
        int i = 0;
        int j = 0;
        while (i < g.length && j < s.length) {
            if (g[i] <= s[j]) {
                res++;
                i++;
                j++;
            } else {
                j++;
            }
        }
        return res;
    }
}

●  376. 摆动序列  Wiggle Subsequence - LeetCode

nums.size() == 1 return 1;

prediff = 0;

curdiff = 0;

res = 1;

for (int i = 0; i < nums.size(); i++)

        curdiff = nums[i + 1] - nums[i];

        if( (prediff >= 0 && curdiff < 0) || (prediff <= 0 && curdiff > 0))

                res++;

                prediff = curdiff;

视频一开始讲解没懂,写完代码懂了。。

class Solution {
    public int wiggleMaxLength(int[] nums) {
        if (nums.length == 1) return 1;
        int preDiff = 0;
        int curDiff = 0;
        int res = 1;

        for (int i = 0; i < nums.length - 1; i++) {
            curDiff = nums[i + 1] - nums[i];
            if (preDiff >= 0 && curDiff < 0 || preDiff <= 0 && curDiff > 0) {
                res++;
                preDiff = curDiff;
            }
        }
        return res;
    }
}

Time complexity: O(n) Space complexity: O(1)

●  53. 最大子序和 Maximum Subarray - LeetCode

int res = Integer.MIN_VALUE;

int count = 0;

for (int i = 0; i < nums.size(); i++)

        count += nums[i];

        if (count > res) res = count;

        if (count < 0) count = 0;//连续和变成负数才变成0

return res;

class Solution {
    public int maxSubArray(int[] nums) {
        int res = Integer.MIN_VALUE;
        int count = 0;

        for (int i = 0; i < nums.length; i++) {
            count += nums[i];
            if (count > res) res = count;
            if (count <= 0) count = 0;
        }
        return res;
    }
}

Time complexity: O(n) Space complexity: O(1)        

第二十二算法训练营主要涵盖了Leetcode题目中的三道题目,分别是Leetcode 28 "Find the Index of the First Occurrence in a String",Leetcode 977 "有序数组的平方",和Leetcode 209 "长度最小的子数组"。 首先是Leetcode 28题,题目要求在给定的字符串中找到第一个出现的字符的索引。思路是使用双指针来遍历字符串,一个指向字符串的开头,另一个指向字符串的结尾。通过比较两个指针所指向的字符是否相等来判断是否找到了第一个出现的字符。具体实现的代码如下: ```python def findIndex(self, s: str) -> int: left = 0 right = len(s) - 1 while left <= right: if s[left == s[right]: return left left += 1 right -= 1 return -1 ``` 接下来是Leetcode 977题,题目要求对给定的有序数组中的元素进行平方,并按照非递减的顺序返回结果。这里由于数组已经是有序的,所以可以使用双指针的方法来解决问题。一个指针指向数组的开头,另一个指针指向数组的末尾。通过比较两个指针所指向的元素的绝对值的大小来确定哪个元素的平方应该放在结果数组的末尾。具体实现的代码如下: ```python def sortedSquares(self, nums: List[int]) -> List[int]: left = 0 right = len(nums) - 1 ans = [] while left <= right: if abs(nums[left]) >= abs(nums[right]): ans.append(nums[left ** 2) left += 1 else: ans.append(nums[right ** 2) right -= 1 return ans[::-1] ``` 最后是Leetcode 209题,题目要求在给定的数组中找到长度最小的子数组,
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值